package dragoscorlatescu.ro.pm_xsi0;

/**
 * Created by Dragos on 25.05.2015.
 */
public class TicTacToe {
    private Integer[] table;

    public TicTacToe() {
        table = new Integer[9];
        for (int i = 0; i < 9; i++) {
            table[i] = -1;
        }
    }

    public void resetTable() {
        int i;

        for (i = 0; i < 9; i++) {
            table[i] = -1;
        }
    }

    public boolean addElement(int type, int poz) {
        if (table[poz] == -1) {
            table[poz] = type;
            return true;
        }
        else {
            return false;
        }
    }

    public int checkWin() {
        int i;

        for (i = 0; i < 3; i++) {
            // check row
            if (table[i * 3] != -1 && table[i * 3] == table[i * 3 + 1] &&
                    table[i * 3] == table[i * 3 + 2]) {
                return table[i * 3];
            }

            // check column
            if (table[i] != -1 && table[i] == table[i + 3] &&
                    table[i] == table[i + 6]) {
                return table[i];
            }
        }

        // check diagonals
        if ((table[0] != -1 && table[0] == table[4] && table[0] == table[8]) ||
                (table[2] != -1 && table[2] == table[4] && table[2] == table[6])) {
            return table[4];
        }

        // check draw
        for (i = 0; i < 9; i++) {
            if (table[i] == -1) {
                // still playing
                return -1;
            }
        }

        // draw
        return -2;
    }
}
